
var slotsfinder = {
  VERSION: 1.0,
  CHANGELOG_URL: 'http://slotsdoc.com/osf-firefox-toolbar.htm',
  prefs: Components.classes["@mozilla.org/preferences-service;1"]
                .getService(Components.interfaces.nsIPrefService)
                .getBranch("extensions.slotsfinder."),
				
  defaults: Components.classes["@mozilla.org/preferences-service;1"]
                .getService(Components.interfaces.nsIPrefService)
                .getDefaultBranch("extensions.slotsfinder."),
//prefs:slotsfinder.prefservice.getBranch("extensions.slotsfinder."),
//defaults:slotsfinder.prefservice.getDefaultBranch("extensions.slotsfinder."),

getMenuitemByValue: function(parentEl,value){  },
optionsDocument: null,
optionsMenupopupFilled: false,
modifyInputs: function(inputs){
	var currPrefs_obj = slotsfinder.getPrefs();
	var currPossible_obj = slotsfinder.getPossibleValues(currPrefs_obj);
	
	for( var i in inputs){
		var menuitems = inputs[i].getElementsByTagName('menuitem');
		if(menuitems.length>0){
			for(var j = 0, l = menuitems.length;j<l;j++){
				if(typeof currPossible_obj[i][menuitems[j].getAttribute('value')] == 'undefined'){
					currPossible_obj[i][menuitems[j].getAttribute('value')] = 0;
				}
				menuitems[j].setAttribute('disabled',(currPossible_obj[i][menuitems[j].getAttribute('value')]==0)?true:false);
			}
		} else {
			inputs[i].setAttribute('disabled',(currPossible_obj[i]==0)?true:false);
			if(currPossible_obj[i]==0){
				inputs[i].setAttribute('checked',false)
			}
		}
	}
},

getCalculatedItems:function(){
	
	var paylines = [];
	var themes = [];
	for (var i=0, iMax=slotsList.length; i<iMax; i++) {
		var payline = slotsList[i][2];
		var theme = slotsList[i][3];
		
		var found = false;
		for (var j=0, jMax=paylines.length; j<jMax; j++) {
			if (paylines[j]==payline) {
				found = true;
				break;
			}
		}
		if (!found) {
			paylines[paylines.length] = payline;
		}
		
		var found = false;
		for (var j=0, jMax=themes.length; j<jMax; j++) {
			if (themes[j]==theme) {
				found = true;
				break;
			}
		}
		if (!found) {
			themes[themes.length] = theme;
		}
	}
	
	paylines.sort(function(a,b) {
		if (a=='all pay') return 1;
		if (b=='all pay') return -1;
		
		return (a-b);
	});
	paylines.unshift('All');
	
	themes.sort(function(a,b) {
		if (a=='Other') return 1;
		if (b=='Other') return -1;
		
		return a>b;
	});
	themes.unshift('All');
	
	return {
		paylines:paylines,
		theme:themes
	}
},

onLoad: function(e) {
// initialization code
	slotsfinder.debug = document.getElementById("slotsfinder-debug");
	
	this.initialized = true;
	
	slotsfinder.tb = document.getElementById("slotsfinder-toolbar");  
	
	document.getElementById("slotsfinder-toolbar-logo").addEventListener('click',function(){slotsfinder.goToURL('http://slotsdoc.com/slots-finder.htm')},false);
	
	
	slotsfinder.getMenuitemByValue = function(parentEl,value){
		 var menuitems = parentEl.getElementsByTagName('menuitem');
		  for(var i=0,l=menuitems.length;i<l;i++){
		  	if(menuitems[i].getAttribute('value') == value){
				return menuitems[i]
			}
		  }
		  return null;
	}
	
	//slotsfinder.debug.setAttribute('value',slotsList);
	slotsfinder.inputs = {
		theme: document.getElementById("slotsfinder-toolbar-theme-select").getElementsByTagName('menulist')[0],
		software:  document.getElementById("slotsfinder-toolbar-soft-select").getElementsByTagName('menulist')[0],
		type:  document.getElementById("slotsfinder-toolbar-type-select").getElementsByTagName('menulist')[0],
	};
	
	slotsfinder.form  = document.getElementById("slotsfinder-result-form")
	
//	var parsedSlotsListCategories = {
//		paylines: {"All":1},
//		theme: {"All":1}
//	};
//	for(var i = 0, l = slotsList.length;i < l; i++){
//		parsedSlotsListCategories.paylines[slotsList[i][2]] = 1;
//		parsedSlotsListCategories.theme[slotsList[i][3]] = 1;
//	}
	
	var parsedSlotsListCategories = slotsfinder.getCalculatedItems();
	
	var prefs_obj = slotsfinder.getPrefs();
	//slotsfinder.debug.setAttribute('value',prefs_obj.theme);
	
	var themepopup = document.getElementById("slotsfinder-toolbar-theme-popup");
	
//	for (theme in parsedSlotsListCategories.theme){
//		var tempItem = document.createElement("menuitem");
//		tempItem.setAttribute("label", theme);
//		tempItem.setAttribute("value", theme);
//		themepopup.appendChild(tempItem);
//	}
	
	for(var i = 0, l = parsedSlotsListCategories.theme.length; i<l; i++){
		var tempItem = document.createElement("menuitem");
		var theme = parsedSlotsListCategories.theme[i];
		tempItem.setAttribute("label", theme);
		tempItem.setAttribute("value", theme);
		themepopup.appendChild(tempItem);
	}
	
	
//	slotsfinder.inputs.theme.selectedItem = slotsfinder.getMenuitemByValue(slotsfinder.inputs.theme,prefs_obj.theme);
//	slotsfinder.inputs.soft.selectedItem = slotsfinder.getMenuitemByValue(slotsfinder.inputs.soft,prefs_obj.soft);
//	slotsfinder.inputs.type.selectedItem = slotsfinder.getMenuitemByValue(slotsfinder.inputs.type,prefs_obj.type);
	
	for(var i in slotsfinder.inputs){
		(function(){
			var curr = i;
			var currInput = slotsfinder.inputs[i];
			currInput.selectedItem = slotsfinder.getMenuitemByValue(currInput,prefs_obj[i]);
			currInput.addEventListener('command',function(e){
				//slotsfinder.debug.setAttribute('value',curr+': '+e.target.getAttribute('value'));
				slotsfinder.setOnePref(curr,e.target.getAttribute('value'));
				slotsfinder.modifyInputs(slotsfinder.inputs);
			},false);}
		)();
	}
	slotsfinder.checkVersion();
	
	slotsfinder.modifyInputs(slotsfinder.inputs);

},

onToolbarButtonCommand: function(e) {
	var toolbar = document.getElementById("slotsfinder-toolbar");
	toolbar.collapsed = !toolbar.collapsed;
	document.persist("slotsfinder-toolbar", "collapsed");
},
  

goToURL: function(url)
{
	window.content.open(url)
    window.content.focus();
},

dialogOk: function()
{
	return true;
},

dialogCancel: function()
{
	return true;
},

dialogOpen: function(){
	var optionsWindow = window.openDialog("chrome://slotsfinder/content/options.xul",
                  "options",
                  "centerscreen, modal, toolbar=no, titlebar, chrome, resizable, dependent");
	
	//slotsfinder.debug.setAttribute('value',slotsfinder.optionsDocument)
	
	//slotsfinder.optionsDocument
},

getPrefs: function(){
	var osf = slotsfinder.prefs;
	
	return {	
		theme: (osf.prefHasUserValue("theme"))?osf.getCharPref("theme"):"All",
		software: (osf.prefHasUserValue("software"))?osf.getCharPref("software"):"All",
		type: (osf.prefHasUserValue("type"))?osf.getCharPref("type"):"All",
		
		paylines: (osf.prefHasUserValue("paylines"))?osf.getCharPref("paylines"):"All",
		
		bonus_round: (osf.prefHasUserValue("bonus_round"))?osf.getBoolPref("bonus_round"):false,
		free_spins: (osf.prefHasUserValue("free_spins"))?osf.getBoolPref("free_spins"):false,
		progressive: (osf.prefHasUserValue("progressive"))?osf.getBoolPref("progressive"):false,
		skill_stop: (osf.prefHasUserValue("skill_stop"))?osf.getBoolPref("skill_stop"):false,
		
		scatter: (osf.prefHasUserValue("scatter"))?osf.getBoolPref("scatter"):false,
		wild: (osf.prefHasUserValue("wild"))?osf.getBoolPref("wild"):false,
		multiplier: (osf.prefHasUserValue("multiplier"))?osf.getBoolPref("multiplier"):false,
		autoplay: (osf.prefHasUserValue("autoplay"))?osf.getBoolPref("autoplay"):false,
		fun_money: (osf.prefHasUserValue("fun_money"))?osf.getBoolPref("fun_money"):false,
		instant_play: (osf.prefHasUserValue("instant_play"))?osf.getBoolPref("instant_play"):false
		
	}
},
resetDefaults: function(){
	var osf = slotsfinder.prefs;
	var osfd = slotsfinder.defaults;
	
	osf.setCharPref("theme",osfd.getCharPref("theme"))
	osf.setCharPref("software",osfd.getCharPref("software"))
	osf.setCharPref("type",osfd.getCharPref("type"))
	
	osf.setCharPref("paylines",osfd.getCharPref("paylines"))
	
	osf.setBoolPref("bonus_round",osfd.getBoolPref("bonus_round"))
	osf.setBoolPref("free_spins",osfd.getBoolPref("free_spins"))
	osf.setBoolPref("progressive",osfd.getBoolPref("progressive"))
	osf.setBoolPref("skill_stop",osfd.getBoolPref("skill_stop"))
	
	osf.setBoolPref("scatter",osfd.getBoolPref("scatter"))
	osf.setBoolPref("wild",osfd.getBoolPref("wild"))
	osf.setBoolPref("multiplier",osfd.getBoolPref("multiplier"))
	osf.setBoolPref("autoplay",osfd.getBoolPref("autoplay"))
	osf.setBoolPref("fun_money",osfd.getBoolPref("fun_money"))
	osf.setBoolPref("instant_play",osfd.getBoolPref("instant_play"))
	
	slotsfinder.modifyInputs(slotsfinder.inputs);
	var prefs_obj = slotsfinder.getPrefs();
	for(var i in slotsfinder.inputs){
		var currInput = slotsfinder.inputs[i];
		currInput.selectedItem = slotsfinder.getMenuitemByValue(currInput,prefs_obj[i]);
	}
},

setOnePref: function(prefName,prefValue){
	
	var prefType = slotsfinder.prefs.getPrefType(prefName);
	if(prefType==slotsfinder.prefs.PREF_BOOL){
		slotsfinder.prefs.setBoolPref(prefName, prefValue);
	} else {
		slotsfinder.prefs.setCharPref(prefName,''+prefValue);
	}
},

findSlots:function(){
//slotsfinder.debug.setAttribute('value',slotsfinder.encode(slotsfinder.getPrefs()))
var dataString = slotsfinder.encode(slotsfinder.getPrefs());

// POST method requests must wrap the encoded text in a MIME
// stream
const Cc = Components.classes;
const Ci = Components.interfaces;
var stringStream = Cc["@mozilla.org/io/string-input-stream;1"].
                   createInstance(Ci.nsIStringInputStream);
if ("data" in stringStream) // Gecko 1.9 or newer
  stringStream.data = dataString;
else // 1.8 or older
  stringStream.setData(dataString, dataString.length);

var postData = Cc["@mozilla.org/network/mime-input-stream;1"].
               createInstance(Ci.nsIMIMEInputStream);
postData.addHeader("Content-Type", "application/x-www-form-urlencoded");
postData.addContentLength = true;
postData.setData(stringStream);



var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
var referer = ioService.newURI('http://slotsdoc.com/toolbar-slots-finder.htm', null, null);


var browser = window.getBrowser();
var b = (browser.selectedTab = browser.addTab()).linkedBrowser;
b.stop();
b.webNavigation.loadURI("http://slotsdoc.com/slots-finder.htm", Components.interfaces.nsIWebNavigation.FLAGS_NONE, referer, postData, null);





},

encode:function(arr){
	var retArr = [];
	for (var i in arr){
		if(!arr[i]) continue;
		if(arr[i] == true) arr[i] = 1;	
		retArr.push(i+'='+encodeURIComponent(arr[i]));
	}
	return retArr.join('&');
},

checkVersion:function(){
	var qwe = setTimeout(function(){
		
		var oldVer = 0;
		try{
			oldVer = parseFloat(slotsfinder.prefs.getCharPref("version"));
		} catch(e){}
		
		if(oldVer < slotsfinder.VERSION){
			try{
				slotsfinder.prefs.setCharPref("version", ""+slotsfinder.VERSION);
			} catch(e){}
			var url = slotsfinder.CHANGELOG_URL + "?ver=" + slotsfinder.VERSION + "&oldver=" + oldVer;
			var browser = window.getBrowser();
			var b = (browser.selectedTab = browser.addTab()).linkedBrowser;
			b.stop();
			b.webNavigation.loadURI(url, Components.interfaces.nsIWebNavigation.FLAGS_NONE, null, null, null);
		}
	},500)


},

getPossibleValues:function (config){
	var result = {
		software: {"All":1},
		type: {"All":1},
		paylines: {"All":1},
		theme: {"All":1},
		progressive: 0,
		bonus_round: 0,
		free_spins: 0,
		skill_stop: 0,
		scatter: 0,
		wild: 0,
		multiplier: 0,
		autoplay: 0,
		fun_money: 0,
		instant_play: 0
	};
	
	function fillSlot(slot) {
		var result = {
			software: slot[0],
			reels: slot[1],
			paylines: slot[2],
			theme: slot[3],
			'i-slots': slot[4],
			progressive: slot[5],
			bonus_round: slot[6],
			free_spins: slot[7],
			skill_stop: slot[8],
			scatter: slot[9],
			wild: slot[10],
			multiplier: slot[11],
			autoplay: slot[12],
			fun_money: slot[13],
			instant_play: slot[14]
		};
		
		if (result['i-slots']) {
			result.type = 'i-slots';
		} else {
			result.type = result.reels+'-reel';
		}
		
		return result;
	}
	
	function isValidBooleans(config, slot) {
		if (config.progressive && !slot.progressive) return false;
		if (config.bonus_round && !slot.bonus_round) return false;
		if (config.free_spins && !slot.free_spins) return false;
		if (config.skill_stop && !slot.skill_stop) return false;
		if (config.scatter && !slot.scatter) return false;
		if (config.wild && !slot.wild) return false;
		if (config.multiplier && !slot.multiplier) return false;
		if (config.autoplay && !slot.autoplay) return false;
		if (config.fun_money && !slot.fun_money) return false;
		if (config.instant_play && !slot.instant_play) return false;
		
		return true;
	}

	var len = slotsList.length;
	for (var i=0; i<len; i++) {
		var slot = fillSlot(slotsList[i]);

		if (config.software!="All" && config.software!=slot.software) continue;
		if (config.paylines!="All" && config.paylines!=slot.paylines) continue;
		if (config.theme!="All" && config.theme!=slot.theme) continue;
		if (config.type!="All") {
			if (config.type!="i-slots") {
				if (config.type!=slot.type) continue;
			} else {
				if (!slot['i-slots']) continue;
			}
		}
		
		if (!isValidBooleans(config, slot)) continue;

		result.software[slot.software] = 1;
		result.type[slot.reels+'-reel'] = 1;
		if (slot['i-slots']) {
			result.type["i-slots"] = 1;
		}
		result.paylines[slot.paylines] = 1;
		result.theme[slot.theme] = 1;
		
		if (slot.progressive) result.progressive = 1;
		if (slot.bonus_round) result.bonus_round = 1;
		if (slot.free_spins) result.free_spins = 1;
		if (slot.skill_stop) result.skill_stop = 1;
		if (slot.scatter) result.scatter = 1;
		if (slot.wild) result.wild = 1;
		if (slot.multiplier) result.multiplier = 1;
		if (slot.autoplay) result.autoplay = 1;
		if (slot.fun_money) result.fun_money = 1;
		if (slot.instant_play) result.instant_play = 1;
	}

	if (config.software!="All") {
		for (var i=0; i<len; i++) {
			var slot = fillSlot(slotsList[i]);

			//if (config.software!="All" && config.software!=slot.software) continue;
			if (config.paylines!="All" && config.paylines!=slot.paylines) continue;
			if (config.theme!="All" && config.theme!=slot.theme) continue;
			if (config.type!="All") {
				if (config.type!="i-slots") {
					if (config.type!=slot.type) continue;
				} else {
					if (!slot['i-slots']) continue;
				}
			}
			
			if (!isValidBooleans(config, slot)) continue;

			result.software[slot.software] = 1;
			//result.type[slot.reels+'-reel'] = 1;
			//if (slot['i-slots']) result.type["i-slots"] = 1;
			//result.paylines[slot.paylines] = 1;
			//result.theme[slot.theme] = 1;
		}
	}
	
	if (config.paylines!="All") {
		for (var i=0; i<len; i++) {
			var slot = fillSlot(slotsList[i]);

			if (config.software!="All" && config.software!=slot.software) continue;
			//if (config.paylines!="All" && config.paylines!=slot.paylines) continue;
			if (config.theme!="All" && config.theme!=slot.theme) continue;
			if (config.type!="All") {
				if (config.type!="i-slots") {
					if (config.type!=slot.type) continue;
				} else {
					if (!slot['i-slots']) continue;
				}
			}
			
			if (!isValidBooleans(config, slot)) continue;

			//result.software[slot.software] = 1;
			//result.type[slot.reels+'-reel'] = 1;
			//if (slot['i-slots']) result.type["i-slots"] = 1;
			result.paylines[slot.paylines] = 1;
			//result.theme[slot.theme] = 1;
		}
	}
	
	if (config.theme!="All") {
		for (var i=0; i<len; i++) {
			var slot = fillSlot(slotsList[i]);

			if (config.software!="All" && config.software!=slot.software) continue;
			if (config.paylines!="All" && config.paylines!=slot.paylines) continue;
			//if (config.theme!="All" && config.theme!=slot.theme) continue;
			if (config.type!="All") {
				if (config.type!="i-slots") {
					if (config.type!=slot.type) continue;
				} else {
					if (!slot['i-slots']) continue;
				}
			}
			
			if (!isValidBooleans(config, slot)) continue;

			//result.software[slot.software] = 1;
			//result.type[slot.reels+'-reel'] = 1;
			//if (slot['i-slots']) result.type["i-slots"] = 1;
			//result.paylines[slot.paylines] = 1;
			result.theme[slot.theme] = 1;
		}
	}
	
	if (config.type!="All") {
		for (var i=0; i<len; i++) {
			var slot = fillSlot(slotsList[i]);

			if (config.software!="All" && config.software!=slot.software) continue;
			if (config.paylines!="All" && config.paylines!=slot.paylines) continue;
			if (config.theme!="All" && config.theme!=slot.theme) continue;
			/*
			if (config.type!="All") {
				if (config.type!="i-slots") {
					if (config.type!=slot.type) continue;
				} else {
					if (!slot['i-slots']) continue;
				}
			}
			*/
			
			if (!isValidBooleans(config, slot)) continue;

			//result.software[slot.software] = 1;
			result.type[slot.reels+'-reel'] = 1;
			if (slot['i-slots']) result.type["i-slots"] = 1;
			//result.paylines[slot.paylines] = 1;
			//result.theme[slot.theme] = 1;
		}
	}

	return result;
}

}
window.addEventListener("load", slotsfinder.onLoad, false);
